LSEEK(2)

NAME
lseek - reposition read/write file offset

SYNOPSIS
#include <unistd.h>
off_t
lseek(int fildes, off_t offset, int whence);

DESCRIPTION
The lseek() function repositions the offset of the file descriptor fildes to the argument offset according to the directive whence. The argument fildes must be an open file descriptor. lseek() repositions the file pointer fildes as follows:

If whence is SEEK_SET, the offset is set to offset bytes.

If whence is SEEK_CUR, the offset is set to its current location plus offset bytes.

If whence is SEEK_END, the offset is set to the size of the file plus offset bytes.

The lseek() function allows the file offset to be set beyond the end of the existing end-of-file of the file. If data is later written at this point, subsequent reads of the data in the gap return bytes of zeros (until data is actually written into the gap).

Some devices are incapable of seeking. The value of the pointer associated with such a device is undefined.

RETURN VALUES
Upon successful completion, lseek() returns the resulting offset location as measured in bytes from the beginning of the file. Otherwise, a value of -1 is returned and errno is set to indicate the error.

ERRORS
lseek() will fail and the file pointer will remain unchanged if:

[EBADF]
    fildes is not an open file descriptor.

[ESPIPE]
    fildes is associated with a pipe, socket, or FIFO.

[EINVAL]
    whence is not a proper value or the resulting offset would be negative on a file system or special device that does not allow negative offsets to be used.

SEE ALSO
dup(2), open(2)

STANDARDS
The lseek() function conforms to p1003.1-88.

HISTORY
A seek() system call first appeared in AT&T UNIX. In AT&T UNIX it was renamed to lseek() for “long seek” due to a larger offset argument type.

BUGS
This document's use of whence is incorrect English, but is maintained for historical reasons.